OGRE-Next: Ogre::Renderable Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Ogre::Renderable Class Referenceabstract
Core | Component » Scene

Abstract class defining the interface all renderable objects must implement. More...

`#include <OgreRenderable.h>`

Inheritance diagram for Ogre::Renderable:
[legend]

## Public Types
typedef map< size_t, Vector4 >::type | CustomParameterMap

## Public Member Functions
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly.
virtual void | _setNullDatablock ()
| Sets the datablock to a null pointer.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
virtual bool | getCastsShadows () const
| Method which reports whether this renderable would normally cast a shadow.
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
virtual const LightList & | getLights () const =0
| Gets a list of lights, ordered relative to how close they are to this renderable.
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
virtual void | getRenderOperation (v1::RenderOperation &op, bool casterPass)=0
| Gets the render operation required to send this object to the frame buffer.
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)
virtual bool | getUseIdentityWorldMatrix () const
| Returns whether the world matrix is an identity matrix.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
virtual void | getWorldTransforms (Matrix4 *xform) const =0
| Gets the world transform matrix / matrices for this renderable object.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Static Public Member Functions
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.

## Public Attributes
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.

## Detailed Description

Abstract class defining the interface all renderable objects must implement.

Remarks
  This interface abstracts renderable discrete objects which will be queued in the render pipeline, grouped by material. Classes implementing this interface must be based on a single material, a single world matrix (or a collection of world matrices which are blended by weights), and must be renderable via a single render operation.

  Note that deciding whether to put these objects in the rendering pipeline is done from the more specific classes e.g. entities. Only once it is decided that the specific class is to be rendered is the abstract version created (could be more than one per visible object) and pushed onto the rendering queue.

## Member Typedef Documentation

## ◆ CustomParameterMap

typedef map<size_t,Vector4>::type Ogre::Renderable::CustomParameterMap

## Constructor & Destructor Documentation

## ◆ Renderable()

Ogre::Renderable::Renderable | ( |  | ) |

## ◆ ~Renderable()

virtual Ogre::Renderable::~Renderable | ( |  | ) |
| virtual

Virtual destructor needed as class has virtual methods.

## Member Function Documentation

## ◆ _setHlmsHashes()

virtual void Ogre::Renderable::_setHlmsHashes | ( | uint32 | hash,
|  | uint32 | casterHash )
| virtual

Manually sets the hlms hashes. Don't call this directly.

Reimplemented in Ogre::SubItem.

## ◆ _setNullDatablock()

virtual void Ogre::Renderable::_setNullDatablock | ( |  | ) |
| virtual

Sets the datablock to a null pointer.

Use case: If you will be destroying an HlmsDatablock and all Renderables associated by it; it makes no sense to change the Renderable's datablock to a default one, only to be destroyed immediately after (you pay an unnecessary performance price).

Remarks
  Do not attempt to render a Renderable whose datablock has been set to null. It will crash. You can call setDatablock afterwards though. Use at your own risk, hence the _underscore. See http://ogre3d.org/forums/viewtopic.php?f=25&t=91791&p=534476#p534476

Reimplemented in Ogre::v1::BillboardSet, and Ogre::v1::SubEntity.

## ◆ _updateCustomGpuParameter()

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters_AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params ) const
| virtual

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters

  constantEntry | The auto constant entry referring to the parameter being updated
  params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::v1::SubEntity.

## ◆ addPoseWeight()

void Ogre::Renderable::addPoseWeight | ( | size_t | index,
|  | float | w )

Referenced by Ogre::SubItem::getCastsShadows().

## ◆ getCastsShadows()

virtual bool Ogre::Renderable::getCastsShadows | ( |  | ) | const
| inlinevirtual

Method which reports whether this renderable would normally cast a shadow.

Remarks
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::ManualObject::ManualObjectSection, Ogre::Rectangle2D, Ogre::SubItem, Ogre::v1::SubEntity, and Ogre::WireAabb.

## ◆ getCurrentMaterialLod()

uint8 Ogre::Renderable::getCurrentMaterialLod | ( |  | ) | const
| inline

## ◆ getCustomParameter()

const Vector4 & Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const
| inline

Gets the custom value associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to retrieve.

See also
  setCustomParameter for full details.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getCustomParameters()

const CustomParameterMap & Ogre::Renderable::getCustomParameters | ( |  | ) | const
| inline

## ◆ getDatablock()

HlmsDatablock * Ogre::Renderable::getDatablock | ( |  | ) | const
| inline

## ◆ getDatablockOrMaterialName()

const String & Ogre::Renderable::getDatablockOrMaterialName | ( |  | ) | const

## ◆ getDefaultRenderQueueSubGroup()

static uint8 Ogre::Renderable::getDefaultRenderQueueSubGroup | ( |  | ) |
| inlinestatic

## ◆ getHlmsCasterHash()

uint32 Ogre::Renderable::getHlmsCasterHash | ( |  | ) | const
| inline

## ◆ getHlmsHash()

uint32 Ogre::Renderable::getHlmsHash | ( |  | ) | const
| inline

## ◆ getLights()

virtual const LightList & Ogre::Renderable::getLights | ( |  | ) | const
| pure virtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implemented in Ogre::Frustum, Ogre::ManualObject::ManualObjectSection, Ogre::Rectangle2D, Ogre::SubItem, Ogre::v1::BillboardChain, Ogre::v1::BillboardSet, Ogre::v1::BorderRenderable, Ogre::v1::ManualObject::ManualObjectSection, Ogre::v1::OverlayElement, Ogre::v1::Rectangle2D, Ogre::v1::SimpleRenderable, Ogre::v1::SubEntity, and Ogre::WireAabb.

## ◆ getMaterial()

MaterialPtr Ogre::Renderable::getMaterial | ( |  | ) | const

Retrieves the material this renderable object uses.

It may be null if it's using the HLMS.

See also
  getDatablock

## ◆ getNumPoses()

unsigned short Ogre::Renderable::getNumPoses | ( |  | ) | const

## ◆ getNumWorldTransforms()

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( |  | ) | const
| inlinevirtual

Returns the number of world transform matrices this renderable requires.

Remarks
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::v1::BorderRenderable, and Ogre::v1::SubEntity.

## ◆ getPolygonModeOverrideable()

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( |  | ) | const
| inlinevirtual

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Reimplemented in Ogre::v1::BorderRenderable.

## ◆ getPoseHalfPrecision()

bool Ogre::Renderable::getPoseHalfPrecision | ( |  | ) | const

## ◆ getPoseNormals()

bool Ogre::Renderable::getPoseNormals | ( |  | ) | const

## ◆ getPoseTexBuffer()

TexBufferPacked * Ogre::Renderable::getPoseTexBuffer | ( |  | ) | const

## ◆ getPoseWeight()

float Ogre::Renderable::getPoseWeight | ( | size_t | index | ) | const

Referenced by Ogre::SubItem::getCastsShadows().

## ◆ getPoseWeights()

float * Ogre::Renderable::getPoseWeights | ( |  | ) | const

## ◆ getRenderOperation()

virtual void Ogre::Renderable::getRenderOperation | ( | v1::RenderOperation & | op,
|  | bool | casterPass )
| pure virtual

Gets the render operation required to send this object to the frame buffer.

Implemented in Ogre::Frustum, Ogre::ManualObject::ManualObjectSection, Ogre::Rectangle2D, Ogre::SubItem, Ogre::v1::BillboardChain, Ogre::v1::BillboardSet, Ogre::v1::BorderRenderable, Ogre::v1::ManualObject::ManualObjectSection, Ogre::v1::PanelOverlayElement, Ogre::v1::Rectangle2D, Ogre::v1::SimpleRenderable, Ogre::v1::SubEntity, Ogre::v1::TextAreaOverlayElement, and Ogre::WireAabb.

## ◆ getRenderQueueSubGroup()

uint8 Ogre::Renderable::getRenderQueueSubGroup | ( |  | ) | const
| inline

## ◆ getUseIdentityProjection()

bool Ogre::Renderable::getUseIdentityProjection | ( |  | ) | const
| inline

Returns whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityProjection

## ◆ getUseIdentityView()

bool Ogre::Renderable::getUseIdentityView | ( |  | ) | const
| inline

Returns whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityView

## ◆ getUseIdentityViewProjMatrixIsDynamic()

virtual bool Ogre::Renderable::getUseIdentityViewProjMatrixIsDynamic | ( |  | ) | const
| inlinevirtual

Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)

Remarks
  Hlms implementations may ignore this setting (e.g. assume always true or always false) or even not support identity matrix overrides at all. For example currently Unlit supports them all, but will assume this returns always true if getUseIdentityWorldMatrix returns false.

## ◆ getUseIdentityWorldMatrix()

virtual bool Ogre::Renderable::getUseIdentityWorldMatrix | ( |  | ) | const
| inlinevirtual

Returns whether the world matrix is an identity matrix.

Remarks
  It is up to the Hlms implementation whether to honour this request. Take in mind changes of this value at runtime may not be seen until the datablock is flushed. It is implemented as a virtual call because this functionality isn't required very often (hence we save per-Renderable space for those that don't use it) and this function will be called at creation time to use a different shader; not during rendering time per Renderable.

Reimplemented in Ogre::v1::BillboardSet.

## ◆ getUserAny()

virtual OGRE_DEPRECATED const Any & Ogre::Renderable::getUserAny | ( |  | ) | const
| inlinevirtual

Deprecated
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead. Retrieves the custom user value associated with this object.

References getUserObjectBindings(), and OGRE_DEPRECATED.

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings & Ogre::Renderable::getUserObjectBindings | ( |  | ) |
| inline

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

Referenced by getUserAny(), and setUserAny().

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings & Ogre::Renderable::getUserObjectBindings | ( |  | ) | const
| inline

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getVaos()

const VertexArrayObjectArray & Ogre::Renderable::getVaos | ( | VertexPass | vertexPass | ) | const
| inline

## ◆ getWorldTransforms()

virtual void Ogre::Renderable::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| pure virtual

Gets the world transform matrix / matrices for this renderable object.

Remarks
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate transform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also
  Matrix4::isAffine.

Implemented in Ogre::Camera, Ogre::Frustum, Ogre::ManualObject::ManualObjectSection, Ogre::Rectangle2D, Ogre::SubItem, Ogre::v1::BillboardChain, Ogre::v1::BillboardSet, Ogre::v1::BorderRenderable, Ogre::v1::ManualObject::ManualObjectSection, Ogre::v1::OverlayElement, Ogre::v1::Rectangle2D, Ogre::v1::SimpleRenderable, Ogre::v1::SubEntity, and Ogre::WireAabb.

## ◆ hasCustomParameter()

bool Ogre::Renderable::hasCustomParameter | ( | size_t | index | ) | const
| inline

Checks whether a custom value is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to check for existence.

See also
  setCustomParameter for full details.

## ◆ hasSkeletonAnimation()

bool Ogre::Renderable::hasSkeletonAnimation | ( |  | ) | const
| inline

## ◆ postRender()

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys )
| inlinevirtual

Called immediately after the Renderable has been rendered.

## ◆ preRender()

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys )
| inlinevirtual

Called just prior to the Renderable being rendered.

Remarks
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Reimplemented in Ogre::v1::BillboardChain.

## ◆ removeCustomParameter()

void Ogre::Renderable::removeCustomParameter | ( | size_t | index | ) |
| inline

Removes a custom value which is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to remove.

See also
  setCustomParameter for full details.

## ◆ setCustomParameter()

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value )
| inline

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters

  index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  value | The value to associate.

## ◆ setDatablock() [1/2]

virtual void Ogre::Renderable::setDatablock | ( | HlmsDatablock * | datablock | ) |
| virtual

Assigns a datablock (i.e. HLMS Material) to this renderable.

Reimplemented in Ogre::v1::BillboardSet, and Ogre::v1::SubEntity.

## ◆ setDatablock() [2/2]

void Ogre::Renderable::setDatablock | ( | IdString | datablockName | ) |

Assigns a datablock (i.e.

HLMS material) based on its unique name.

Remarks
  An null IdString() is valid, it will use the default material

Referenced by Ogre::v1::SubEntity::setMaterial().

## ◆ setDatablockOrMaterialName()

void Ogre::Renderable::setDatablockOrMaterialName | ( | String | materialName,
|  | String | groupName )

First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.

## ◆ setDefaultRenderQueueSubGroup()

static void Ogre::Renderable::setDefaultRenderQueueSubGroup | ( | uint8 | subGroup | ) |
| inlinestatic

Sets the default render queue sub group for all future Renderable instances.

## ◆ setMaterial()

virtual void Ogre::Renderable::setMaterial | ( | const MaterialPtr & | material | ) |
| virtual

Sets the given material. Overrides HLMS materials.

Reimplemented in Ogre::v1::BillboardSet, Ogre::v1::SimpleRenderable, and Ogre::v1::SubEntity.

## ◆ setMaterialName()

void Ogre::Renderable::setMaterialName | ( | const String & | name,
|  | const String & | groupName )

Sets the name of the Material to be used. Prefer using HLMS.

See also
  setHlms

## ◆ setPolygonModeOverrideable()

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) |
| inlinevirtual

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters

  override | true means that a lower camera detail will override this renderables detail level, false means it won't.

## ◆ setPoseWeight()

void Ogre::Renderable::setPoseWeight | ( | size_t | index,
|  | float | w )

Referenced by Ogre::SubItem::getCastsShadows().

## ◆ setRenderQueueSubGroup()

void Ogre::Renderable::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |
| inline

Sets the render queue sub group.

Remarks
  Within the same RenderQueue ID, you may want to have the renderables to have a specific order (i.e. have a mesh, but the hair submesh with alpha blending needs to be rendered last).

  RenderQueue Subgroups are useful for manually sorting objects, just like RenderQueue IDs. However, RenderQueue IDs can also be useful for skipping large number of objects through clever compositing and thus a performance optimization. Subgroups cannot be used for such optimizations.

Parameters

  subGroup | The sub group. This value can't exceed OGRE_MAKE_MASK( SubRqIdBits )

See also
  RenderQueue

## ◆ setUseIdentityProjection()

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |
| inline

Sets whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityProjection

## ◆ setUseIdentityView()

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) |
| inline

Sets whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityView

## ◆ setUserAny()

virtual OGRE_DEPRECATED void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) |
| inlinevirtual

Deprecated
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead. Sets any kind of user value on this object.

Remarks
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

References getUserObjectBindings(), and OGRE_DEPRECATED.

## Member Data Documentation

## ◆ mCustomParameter

uint8 Ogre::Renderable::mCustomParameter

## ◆ mHlmsGlobalIndex

uint32 Ogre::Renderable::mHlmsGlobalIndex

Index in the vector holding this Rendrable reference in the HLMS datablock.

Used for O(1) removals.

Remarks
  Despite being public, Do NOT modify it manually.

## ◆ mRenderableVisible

bool Ogre::Renderable::mRenderableVisible

Control visibility at Renderable (e.g.

SubMesh) level

Note that if our MovableObject owner called MovableObject::setVisible( false ) we won't get rendered. Both must be true in order to render.

Remarks
  PUBLIC VARIABLE. This variable can be altered directly. Changes are reflected immediately.

The documentation for this class was generated from the following file:

- OgreRenderable.h